Index: Makefile
===================================================================
--- Makefile	(revision bca408bfd84743b83b4ee34646013041a86f2ccf)
+++ Makefile	(revision 1715b6af7847ebb95ae42eba99295f3291f1d1b5)
@@ -59,5 +59,5 @@
 
 distclean: clean
-	rm -f $(CSCOPE).out Makefile.config config.h config.defs tools/*.pyc tools/checkers/*.pyc
+	rm -f $(CSCOPE).out Makefile.config config.h config.defs tools/*.pyc
 
 clean:
Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision bca408bfd84743b83b4ee34646013041a86f2ccf)
+++ boot/Makefile.common	(revision 1715b6af7847ebb95ae42eba99295f3291f1d1b5)
@@ -56,6 +56,5 @@
 	$(USPACEDIR)/srv/fs/devfs/devfs \
 	$(USPACEDIR)/srv/fs/tmpfs/tmpfs \
-	$(USPACEDIR)/srv/fs/fat/fat \
-	$(USPACEDIR)/srv/taskmon/taskmon
+	$(USPACEDIR)/srv/fs/fat/fat
 
 RD_APPS = \
@@ -66,5 +65,4 @@
 	$(USPACEDIR)/app/mkfat/mkfat \
 	$(USPACEDIR)/app/redir/redir \
-	$(USPACEDIR)/app/taskdump/taskdump \
 	$(USPACEDIR)/app/tester/tester \
 	$(USPACEDIR)/app/tetris/tetris \
Index: kernel/generic/include/interrupt.h
===================================================================
--- kernel/generic/include/interrupt.h	(revision bca408bfd84743b83b4ee34646013041a86f2ccf)
+++ kernel/generic/include/interrupt.h	(revision 1715b6af7847ebb95ae42eba99295f3291f1d1b5)
@@ -46,5 +46,17 @@
 typedef void (* iroutine)(int n, istate_t *istate);
 
-extern void fault_if_from_uspace(istate_t *istate, char *fmt, ...);
+#define fault_if_from_uspace(istate, fmt, ...) \
+{ \
+	if (istate_from_uspace(istate)) { \
+		task_t *task = TASK; \
+		printf("Task %s (%" PRIu64 ") killed due to an exception at " \
+		    "program counter %p.\n", task->name, task->taskid, istate_get_pc(istate)); \
+		stack_trace_istate(istate); \
+		printf("Kill message: " fmt "\n", ##__VA_ARGS__); \
+		task_kill(task->taskid); \
+		thread_exit(); \
+	} \
+}
+
 extern iroutine exc_register(int n, const char *name, iroutine f);
 extern void exc_dispatch(int n, istate_t *t);
Index: kernel/generic/include/ipc/event_types.h
===================================================================
--- kernel/generic/include/ipc/event_types.h	(revision bca408bfd84743b83b4ee34646013041a86f2ccf)
+++ kernel/generic/include/ipc/event_types.h	(revision 1715b6af7847ebb95ae42eba99295f3291f1d1b5)
@@ -37,10 +37,6 @@
 
 typedef enum event_type {
-	/** New data available in kernel log */
 	EVENT_KLOG = 0,
-	/** Returning from kernel console to userspace */
 	EVENT_KCONSOLE,
-	/** A thread has faulted and will be terminated */
-	EVENT_FAULT,
 	EVENT_END
 } event_type_t;
Index: kernel/generic/include/mm/as.h
===================================================================
--- kernel/generic/include/mm/as.h	(revision bca408bfd84743b83b4ee34646013041a86f2ccf)
+++ kernel/generic/include/mm/as.h	(revision 1715b6af7847ebb95ae42eba99295f3291f1d1b5)
@@ -36,10 +36,4 @@
 #define KERN_AS_H_
 
-#ifdef KERNEL
-#include <arch/types.h>
-#else
-#include <sys/types.h>
-#endif
-
 /** Address space area flags. */
 #define AS_AREA_READ		1
@@ -47,16 +41,4 @@
 #define AS_AREA_EXEC		4
 #define AS_AREA_CACHEABLE	8
-
-/** Address space area info exported to userspace. */
-typedef struct {
-	/** Starting address */
-	uintptr_t start_addr;
-
-	/** Area size */
-	size_t size;
-
-	/** Area flags */
-	int flags;
-} as_area_info_t;
 
 #ifdef KERNEL
@@ -286,5 +268,4 @@
 
 /* Introspection functions. */
-extern void as_get_area_info(as_t *as, as_area_info_t **obuf, size_t *osize);
 extern void as_print(as_t *as);
 
Index: kernel/generic/include/udebug/udebug.h
===================================================================
--- kernel/generic/include/udebug/udebug.h	(revision bca408bfd84743b83b4ee34646013041a86f2ccf)
+++ kernel/generic/include/udebug/udebug.h	(revision 1715b6af7847ebb95ae42eba99295f3291f1d1b5)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup generic	
  * @{
  */
@@ -83,15 +83,4 @@
 UDEBUG_M_ARGS_READ,
 
-/** Read thread's userspace register state (istate_t).
- *
- * - ARG2 - thread identification
- * - ARG3 - destination address in the caller's address space
- *
- * or, on error, retval will be
- * - ENOENT - thread does not exist
- * - EBUSY - register state not available
- */
-UDEBUG_M_REGS_READ,
-
 /** Read the list of the debugged tasks's threads.
  *
@@ -107,31 +96,4 @@
  */
 UDEBUG_M_THREAD_READ,
-
-/** Read the name of the debugged task.
- *
- * - ARG2 - destination address in the caller's address space
- * - ARG3 - size of receiving buffer in bytes
- *
- * The kernel fills the buffer with a non-terminated string.
- *
- * - ARG2 - number of bytes that were actually copied
- * - ARG3 - number of bytes of the complete data
- *
- */
-UDEBUG_M_NAME_READ,
-
-/** Read the list of the debugged task's address space areas.
- *
- * - ARG2 - destination address in the caller's address space
- * - ARG3 - size of receiving buffer in bytes
- *
- * The kernel fills the buffer with a series of as_area_info_t structures.
- * Upon answer, the kernel will set:
- *
- * - ARG2 - number of bytes that were actually copied
- * - ARG3 - number of bytes of the complete data
- *
- */
-UDEBUG_M_AREAS_READ,
 
 /** Read the debugged tasks's memory.
@@ -146,5 +108,5 @@
 } udebug_method_t;
 
-
+				
 typedef enum {
 	UDEBUG_EVENT_FINISHED = 1,	/**< Debuging session has finished */
@@ -177,5 +139,4 @@
 
 #include <synch/mutex.h>
-#include <synch/condvar.h>
 #include <arch/interrupt.h>
 #include <atomic.h>
@@ -220,5 +181,4 @@
 	bool stoppable;		/**< thread is stoppable */
 	bool active;		/**< thread is in a debugging session */
-	condvar_t active_cv;
 } udebug_thread_t;
 
@@ -242,5 +202,4 @@
 
 int udebug_task_cleanup(struct task *ta);
-void udebug_thread_fault(void);
 
 #endif
Index: kernel/generic/include/udebug/udebug_ops.h
===================================================================
--- kernel/generic/include/udebug/udebug_ops.h	(revision bca408bfd84743b83b4ee34646013041a86f2ccf)
+++ kernel/generic/include/udebug/udebug_ops.h	(revision 1715b6af7847ebb95ae42eba99295f3291f1d1b5)
@@ -45,10 +45,6 @@
 int udebug_stop(thread_t *t, call_t *call);
 
-int udebug_thread_read(void **buffer, size_t buf_size, size_t *stored,
-    size_t *needed);
-int udebug_name_read(char **data, size_t *data_size);
+int udebug_thread_read(void **buffer, size_t buf_size, size_t *n);
 int udebug_args_read(thread_t *t, void **buffer);
-
-int udebug_regs_read(thread_t *t, void **buffer);
 
 int udebug_mem_read(unative_t uspace_addr, size_t n, void **buffer);
Index: kernel/generic/src/interrupt/interrupt.c
===================================================================
--- kernel/generic/src/interrupt/interrupt.c	(revision bca408bfd84743b83b4ee34646013041a86f2ccf)
+++ kernel/generic/src/interrupt/interrupt.c	(revision 1715b6af7847ebb95ae42eba99295f3291f1d1b5)
@@ -44,8 +44,4 @@
 #include <console/console.h>
 #include <console/cmd.h>
-#include <ipc/event.h>
-#include <synch/mutex.h>
-#include <time/delay.h>
-#include <macros.h>
 #include <panic.h>
 #include <print.h>
@@ -111,46 +107,4 @@
 	fault_if_from_uspace(istate, "Unhandled exception %d.", n);
 	panic("Unhandled exception %d.", n);
-}
-
-/** Terminate thread and task if exception came from userspace. */
-void fault_if_from_uspace(istate_t *istate, char *fmt, ...)
-{
-	task_t *task = TASK;
-	va_list args;
-
-	if (!istate_from_uspace(istate))
-		return;
-
-	printf("Task %s (%" PRIu64 ") killed due to an exception at "
-	    "program counter %p.\n", task->name, task->taskid,
-	    istate_get_pc(istate));
-
-	stack_trace_istate(istate);
-
-	printf("Kill message: ");
-	va_start(args, fmt);
-	vprintf(fmt, args);
-	va_end(args);
-	printf("\n");
-
-	/*
-	 * Userspace can subscribe for FAULT events to take action
-	 * whenever a thread faults. (E.g. take a dump, run a debugger).
-	 * The notification is always available, but unless Udebug is enabled,
-	 * that's all you get.
-	 */
-	if (event_is_subscribed(EVENT_FAULT)) {
-		/* Notify the subscriber that a fault occurred. */
-		event_notify_3(EVENT_FAULT, LOWER32(TASK->taskid),
-		    UPPER32(TASK->taskid), (unative_t) THREAD);
-
-#ifdef CONFIG_UDEBUG
-		/* Wait for a debugging session. */
-		udebug_thread_fault();
-#endif
-	}
-
-	task_kill(task->taskid);
-	thread_exit();
 }
 
Index: kernel/generic/src/mm/as.c
===================================================================
--- kernel/generic/src/mm/as.c	(revision bca408bfd84743b83b4ee34646013041a86f2ccf)
+++ kernel/generic/src/mm/as.c	(revision 1715b6af7847ebb95ae42eba99295f3291f1d1b5)
@@ -1920,70 +1920,4 @@
 }
 
-/** Get list of adress space areas.
- *
- * @param as		Address space.
- * @param obuf		Place to save pointer to returned buffer.
- * @param osize		Place to save size of returned buffer.
- */
-void as_get_area_info(as_t *as, as_area_info_t **obuf, size_t *osize)
-{
-	ipl_t ipl;
-	size_t area_cnt, area_idx, i;
-	link_t *cur;
-
-	as_area_info_t *info;
-	size_t isize;
-
-	ipl = interrupts_disable();
-	mutex_lock(&as->lock);
-
-	/* First pass, count number of areas. */
-
-	area_cnt = 0;
-
-	for (cur = as->as_area_btree.leaf_head.next;
-	    cur != &as->as_area_btree.leaf_head; cur = cur->next) {
-		btree_node_t *node;
-
-		node = list_get_instance(cur, btree_node_t, leaf_link);
-		area_cnt += node->keys;
-	}
-
-        isize = area_cnt * sizeof(as_area_info_t);
-	info = malloc(isize, 0);
-
-	/* Second pass, record data. */
-
-	area_idx = 0;
-
-	for (cur = as->as_area_btree.leaf_head.next;
-	    cur != &as->as_area_btree.leaf_head; cur = cur->next) {
-		btree_node_t *node;
-
-		node = list_get_instance(cur, btree_node_t, leaf_link);
-
-		for (i = 0; i < node->keys; i++) {
-			as_area_t *area = node->value[i];
-
-			ASSERT(area_idx < area_cnt);
-			mutex_lock(&area->lock);
-
-			info[area_idx].start_addr = area->base;
-			info[area_idx].size = FRAMES2SIZE(area->pages);
-			info[area_idx].flags = area->flags;
-			++area_idx;
-
-			mutex_unlock(&area->lock);
-		}
-	}
-
-	mutex_unlock(&as->lock);
-	interrupts_restore(ipl);
-
-	*obuf = info;
-	*osize = isize;
-}
-
-
 /** Print out information about address space.
  *
Index: kernel/generic/src/udebug/udebug.c
===================================================================
--- kernel/generic/src/udebug/udebug.c	(revision bca408bfd84743b83b4ee34646013041a86f2ccf)
+++ kernel/generic/src/udebug/udebug.c	(revision 1715b6af7847ebb95ae42eba99295f3291f1d1b5)
@@ -69,5 +69,4 @@
 	mutex_initialize(&ut->lock, MUTEX_PASSIVE);
 	waitq_initialize(&ut->go_wq);
-	condvar_initialize(&ut->active_cv);
 
 	ut->go_call = NULL;
@@ -447,9 +446,6 @@
 				waitq_wakeup(&t->udebug.go_wq, WAKEUP_FIRST);
 			}
-			mutex_unlock(&t->udebug.lock);
-			condvar_broadcast(&t->udebug.active_cv);
-		} else {
-			mutex_unlock(&t->udebug.lock);
 		}
+		mutex_unlock(&t->udebug.lock);
 	}
 
@@ -460,29 +456,4 @@
 }
 
-/** Wait for debugger to handle a fault in this thread.
- *
- * When a thread faults and someone is subscribed to the FAULT kernel event,
- * this function is called to wait for a debugging session to give userspace
- * a chance to examine the faulting thead/task. When the debugging session
- * is over, this function returns (so that thread/task cleanup can continue).
- */
-void udebug_thread_fault(void)
-{
-	udebug_stoppable_begin();
-
-	/* Wait until a debugger attends to us. */
-	mutex_lock(&THREAD->udebug.lock);
-	while (!THREAD->udebug.active)
-		condvar_wait(&THREAD->udebug.active_cv, &THREAD->udebug.lock);
-	mutex_unlock(&THREAD->udebug.lock);
-
-	/* Make sure the debugging session is over before proceeding. */
-	mutex_lock(&THREAD->udebug.lock);
-	while (THREAD->udebug.active)
-		condvar_wait(&THREAD->udebug.active_cv, &THREAD->udebug.lock);
-	mutex_unlock(&THREAD->udebug.lock);
-
-	udebug_stoppable_end();
-}
 
 /** @}
Index: kernel/generic/src/udebug/udebug_ipc.c
===================================================================
--- kernel/generic/src/udebug/udebug_ipc.c	(revision bca408bfd84743b83b4ee34646013041a86f2ccf)
+++ kernel/generic/src/udebug/udebug_ipc.c	(revision 1715b6af7847ebb95ae42eba99295f3291f1d1b5)
@@ -41,5 +41,4 @@
 #include <proc/task.h>
 #include <proc/thread.h>
-#include <mm/as.h>
 #include <arch.h>
 #include <errno.h>
@@ -166,8 +165,10 @@
 static void udebug_receive_thread_read(call_t *call)
 {
-	uintptr_t uspace_addr;
-	size_t buf_size;
+	unative_t uspace_addr;
+	unative_t to_copy;
+	unsigned total_bytes;
+	unsigned buf_size;
 	void *buffer;
-	size_t copied, needed;
+	size_t n;
 	int rc;
 
@@ -179,5 +180,5 @@
 	 * of threads times thread-id size.
 	 */
-	rc = udebug_thread_read(&buffer, buf_size, &copied, &needed);
+	rc = udebug_thread_read(&buffer, buf_size, &n);
 	if (rc < 0) {
 		IPC_SET_RETVAL(call->data, rc);
@@ -186,46 +187,10 @@
 	}
 
-	/*
-	 * Make use of call->buffer to transfer data to caller's userspace
-	 */
-
-	IPC_SET_RETVAL(call->data, 0);
-	/* ARG1=dest, ARG2=size as in IPC_M_DATA_READ so that
-	   same code in process_answer() can be used 
-	   (no way to distinguish method in answer) */
-	IPC_SET_ARG1(call->data, uspace_addr);
-	IPC_SET_ARG2(call->data, copied);
-	IPC_SET_ARG3(call->data, needed);
-	call->buffer = buffer;
-
-	ipc_answer(&TASK->kb.box, call);
-}
-
-/** Process a NAME_READ call.
- *
- * Returns a string containing the name of the task.
- *
- * @param call	The call structure.
- */
-static void udebug_receive_name_read(call_t *call)
-{
-	unative_t uspace_addr;
-	unative_t to_copy;
-	size_t data_size;
-	size_t buf_size;
-	void *data;
-
-	uspace_addr = IPC_GET_ARG2(call->data);	/* Destination address */
-	buf_size = IPC_GET_ARG3(call->data);	/* Dest. buffer size */
-
-	/*
-	 * Read task name.
-	 */
-	udebug_name_read((char **) &data, &data_size);
-
-	/* Copy MAX(buf_size, data_size) bytes */
-
-	if (buf_size > data_size)
-		to_copy = data_size;
+	total_bytes = n;
+
+	/* Copy MAX(buf_size, total_bytes) bytes */
+
+	if (buf_size > total_bytes)
+		to_copy = total_bytes;
 	else
 		to_copy = buf_size;
@@ -242,57 +207,9 @@
 	IPC_SET_ARG2(call->data, to_copy);
 
-	IPC_SET_ARG3(call->data, data_size);
-	call->buffer = data;
-
-	ipc_answer(&TASK->kb.box, call);
-}
-
-/** Process an AREAS_READ call.
- *
- * Returns a list of address space areas in the current task, as an array
- * of as_area_info_t structures.
- *
- * @param call	The call structure.
- */
-static void udebug_receive_areas_read(call_t *call)
-{
-	unative_t uspace_addr;
-	unative_t to_copy;
-	size_t data_size;
-	size_t buf_size;
-	void *data;
-
-	uspace_addr = IPC_GET_ARG2(call->data);	/* Destination address */
-	buf_size = IPC_GET_ARG3(call->data);	/* Dest. buffer size */
-
-	/*
-	 * Read area list.
-	 */
-	as_get_area_info(AS, (as_area_info_t **) &data, &data_size);
-
-	/* Copy MAX(buf_size, data_size) bytes */
-
-	if (buf_size > data_size)
-		to_copy = data_size;
-	else
-		to_copy = buf_size;
-
-	/*
-	 * Make use of call->buffer to transfer data to caller's userspace
-	 */
-
-	IPC_SET_RETVAL(call->data, 0);
-	/* ARG1=dest, ARG2=size as in IPC_M_DATA_READ so that
-	   same code in process_answer() can be used 
-	   (no way to distinguish method in answer) */
-	IPC_SET_ARG1(call->data, uspace_addr);
-	IPC_SET_ARG2(call->data, to_copy);
-
-	IPC_SET_ARG3(call->data, data_size);
-	call->buffer = data;
-
-	ipc_answer(&TASK->kb.box, call);
-}
-
+	IPC_SET_ARG3(call->data, total_bytes);
+	call->buffer = buffer;
+
+	ipc_answer(&TASK->kb.box, call);
+}
 
 /** Process an ARGS_READ call.
@@ -333,45 +250,4 @@
 	ipc_answer(&TASK->kb.box, call);
 }
-
-/** Receive a REGS_READ call.
- *
- * Reads the thread's register state (istate structure).
- */
-static void udebug_receive_regs_read(call_t *call)
-{
-	thread_t *t;
-	unative_t uspace_addr;
-	unative_t to_copy;
-	void *buffer;
-	int rc;
-
-	t = (thread_t *) IPC_GET_ARG2(call->data);
-
-	rc = udebug_regs_read(t, &buffer);
-	if (rc < 0) {
-		IPC_SET_RETVAL(call->data, rc);
-		ipc_answer(&TASK->kb.box, call);
-		return;
-	}
-
-	/*
-	 * Make use of call->buffer to transfer data to caller's userspace
-	 */
-
-	uspace_addr = IPC_GET_ARG3(call->data);
-	to_copy = sizeof(istate_t);
-
-	IPC_SET_RETVAL(call->data, 0);
-	/* ARG1=dest, ARG2=size as in IPC_M_DATA_READ so that
-	   same code in process_answer() can be used 
-	   (no way to distinguish method in answer) */
-	IPC_SET_ARG1(call->data, uspace_addr);
-	IPC_SET_ARG2(call->data, to_copy);
-
-	call->buffer = buffer;
-
-	ipc_answer(&TASK->kb.box, call);
-}
-
 
 /** Process an MEM_READ call.
@@ -455,16 +331,7 @@
 		udebug_receive_thread_read(call);
 		break;
-	case UDEBUG_M_NAME_READ:
-		udebug_receive_name_read(call);
-		break;
-	case UDEBUG_M_AREAS_READ:
-		udebug_receive_areas_read(call);
-		break;
 	case UDEBUG_M_ARGS_READ:
 		udebug_receive_args_read(call);
 		break;
-	case UDEBUG_M_REGS_READ:
-		udebug_receive_regs_read(call);
-		break;
 	case UDEBUG_M_MEM_READ:
 		udebug_receive_mem_read(call);
Index: kernel/generic/src/udebug/udebug_ops.c
===================================================================
--- kernel/generic/src/udebug/udebug_ops.c	(revision bca408bfd84743b83b4ee34646013041a86f2ccf)
+++ kernel/generic/src/udebug/udebug_ops.c	(revision 1715b6af7847ebb95ae42eba99295f3291f1d1b5)
@@ -46,5 +46,4 @@
 #include <errno.h>
 #include <print.h>
-#include <string.h>
 #include <syscall/copy.h>
 #include <ipc/ipc.h>
@@ -210,11 +209,7 @@
 
 		mutex_lock(&t->udebug.lock);
-		if ((t->flags & THREAD_FLAG_USPACE) != 0) {
+		if ((t->flags & THREAD_FLAG_USPACE) != 0)
 			t->udebug.active = true;
-			mutex_unlock(&t->udebug.lock);
-			condvar_broadcast(&t->udebug.active_cv);
-		} else {
-			mutex_unlock(&t->udebug.lock);
-		}
+		mutex_unlock(&t->udebug.lock);
 	}
 
@@ -360,7 +355,6 @@
  *
  * If the sequence is longer than @a buf_size bytes, only as much hashes
- * as can fit are copied. The number of bytes copied is stored in @a stored.
- * The total number of thread bytes that could have been saved had there been
- * enough space is stored in @a needed.
+ * as can fit are copied. The number of thread hashes copied is stored
+ * in @a n.
  *
  * The rationale for having @a buf_size is that this function is only
@@ -370,15 +364,12 @@
  * @param buffer	The buffer for storing thread hashes.
  * @param buf_size	Buffer size in bytes.
- * @param stored	The actual number of bytes copied will be stored here.
- * @param needed	Total number of hashes that could have been saved.
- */
-int udebug_thread_read(void **buffer, size_t buf_size, size_t *stored,
-    size_t *needed)
+ * @param n		The actual number of hashes copied will be stored here.
+ */
+int udebug_thread_read(void **buffer, size_t buf_size, size_t *n)
 {
 	thread_t *t;
 	link_t *cur;
 	unative_t tid;
-	size_t copied_ids;
-	size_t extra_ids;
+	unsigned copied_ids;
 	ipl_t ipl;
 	unative_t *id_buffer;
@@ -389,5 +380,5 @@
 
 	/* Allocate a buffer to hold thread IDs */
-	id_buffer = malloc(buf_size + 1, 0);
+	id_buffer = malloc(buf_size, 0);
 
 	mutex_lock(&TASK->udebug.lock);
@@ -405,8 +396,10 @@
 	max_ids = buf_size / sizeof(unative_t);
 	copied_ids = 0;
-	extra_ids = 0;
 
 	/* FIXME: make sure the thread isn't past debug shutdown... */
 	for (cur = TASK->th_head.next; cur != &TASK->th_head; cur = cur->next) {
+		/* Do not write past end of buffer */
+		if (copied_ids >= max_ids) break;
+
 		t = list_get_instance(cur, thread_t, th_link);
 
@@ -416,13 +409,8 @@
 
 		/* Not interested in kernel threads. */
-		if ((flags & THREAD_FLAG_USPACE) == 0)
-			continue;
-
-		if (copied_ids < max_ids) {
+		if ((flags & THREAD_FLAG_USPACE) != 0) {
 			/* Using thread struct pointer as identification hash */
 			tid = (unative_t) t;
 			id_buffer[copied_ids++] = tid;
-		} else {
-			extra_ids++;
 		}
 	}
@@ -434,29 +422,5 @@
 
 	*buffer = id_buffer;
-	*stored = copied_ids * sizeof(unative_t);
-	*needed = (copied_ids + extra_ids) * sizeof(unative_t);
-
-	return 0;
-}
-
-/** Read task name.
- *
- * Returns task name as non-terminated string in a newly allocated buffer.
- * Also returns the size of the data.
- *
- * @param data		Place to store pointer to newly allocated block.
- * @param data_size	Place to store size of the data.
- *
- * @returns		EOK.
- */
-int udebug_name_read(char **data, size_t *data_size)
-{
-	size_t name_size;
-
-	name_size = str_size(TASK->name) + 1;
-	*data = malloc(name_size, 0);
-	*data_size = name_size;
-
-	memcpy(*data, TASK->name, name_size);
+	*n = copied_ids * sizeof(unative_t);
 
 	return 0;
@@ -473,8 +437,5 @@
  * this function will fail with an EINVAL error code.
  *
- * @param t		Thread where call arguments are to be read.
- * @param buffer	Place to store pointer to new buffer.
- * @return		EOK on success, ENOENT if @a t is invalid, EINVAL
- *			if thread state is not valid for this operation.
+ * @param buffer	The buffer for storing thread hashes.
  */
 int udebug_args_read(thread_t *t, void **buffer)
@@ -508,48 +469,4 @@
 }
 
-/** Read the register state of the thread.
- *
- * The contents of the thread's istate structure are copied to a newly
- * allocated buffer and a pointer to it is written to @a buffer. The size of
- * the buffer will be sizeof(istate_t).
- *
- * Currently register state cannot be read if the thread is inside a system
- * call (as opposed to an exception). This is an implementation limit.
- *
- * @param t		Thread whose state is to be read.
- * @param buffer	Place to store pointer to new buffer.
- * @return		EOK on success, ENOENT if @a t is invalid, EINVAL
- *			if thread is not in valid state, EBUSY if istate
- *			is not available.
- */
-int udebug_regs_read(thread_t *t, void **buffer)
-{
-	istate_t *state, *state_buf;
-	int rc;
-
-	/* Prepare a buffer to hold the data. */
-	state_buf = malloc(sizeof(istate_t), 0);
-
-	/* On success, this will lock t->udebug.lock */
-	rc = _thread_op_begin(t, false);
-	if (rc != EOK) {
-		return rc;
-	}
-
-	state = t->udebug.uspace_state;
-	if (state == NULL) {
-		_thread_op_end(t);
-		return EBUSY;
-	}
-
-	/* Copy to the allocated buffer */
-	memcpy(state_buf, state, sizeof(istate_t));
-
-	_thread_op_end(t);
-
-	*buffer = (void *) state_buf;
-	return 0;
-}
-
 /** Read the memory of the debugged task.
  *
Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision bca408bfd84743b83b4ee34646013041a86f2ccf)
+++ uspace/Makefile	(revision 1715b6af7847ebb95ae42eba99295f3291f1d1b5)
@@ -40,5 +40,4 @@
 	app/mkfat \
 	app/redir \
-	app/taskdump \
 	app/tester \
 	app/tetris \
@@ -48,5 +47,4 @@
 	srv/loader \
 	srv/ns \
-	srv/taskmon \
 	srv/vfs \
 	srv/bd/ata_bd \
Index: uspace/app/init/init.c
===================================================================
--- uspace/app/init/init.c	(revision bca408bfd84743b83b4ee34646013041a86f2ccf)
+++ uspace/app/init/init.c	(revision 1715b6af7847ebb95ae42eba99295f3291f1d1b5)
@@ -233,18 +233,4 @@
 }
 
-static void mount_scratch(void)
-{
-	int rc;
-
-	printf("Trying to mount null/0 on /scratch... ");
-	fflush(stdout);
-
-	rc = mount("tmpfs", "/scratch", "null/0", "", 0);
-	if (rc == EOK)
-		printf("OK\n");
-	else
-		printf("Failed\n");
-}
-
 static void mount_data(void)
 {
@@ -269,12 +255,6 @@
 		return -1;
 	}
-
-	/* Make sure tmpfs is running. */
-	if (str_cmp(STRING(RDFMT), "tmpfs") != 0) {
-		spawn("/srv/tmpfs");
-	}
 	
 	spawn("/srv/devfs");
-	spawn("/srv/taskmon");
 	
 	if (!mount_devfs()) {
@@ -282,6 +262,4 @@
 		return -2;
 	}
-
-	mount_scratch();
 	
 	spawn("/srv/fhc");
Index: uspace/lib/libc/arch/amd64/Makefile.inc
===================================================================
--- uspace/lib/libc/arch/amd64/Makefile.inc	(revision bca408bfd84743b83b4ee34646013041a86f2ccf)
+++ uspace/lib/libc/arch/amd64/Makefile.inc	(revision 1715b6af7847ebb95ae42eba99295f3291f1d1b5)
@@ -37,6 +37,5 @@
 	arch/$(UARCH)/src/fibril.S \
 	arch/$(UARCH)/src/tls.c \
-	arch/$(UARCH)/src/stacktrace.c \
-	arch/$(UARCH)/src/stacktrace_asm.S
+	arch/$(UARCH)/src/stacktrace.S
 
 GCC_CFLAGS += -fno-omit-frame-pointer
Index: uspace/lib/libc/arch/amd64/include/types.h
===================================================================
--- uspace/lib/libc/arch/amd64/include/types.h	(revision bca408bfd84743b83b4ee34646013041a86f2ccf)
+++ uspace/lib/libc/arch/amd64/include/types.h	(revision 1715b6af7847ebb95ae42eba99295f3291f1d1b5)
@@ -36,6 +36,4 @@
 #define LIBC_amd64_TYPES_H_
 
-#define __64_BITS__
-
 typedef unsigned long long sysarg_t;
 
Index: uspace/lib/libc/arch/amd64/src/stacktrace.S
===================================================================
--- uspace/lib/libc/arch/amd64/src/stacktrace.S	(revision 1715b6af7847ebb95ae42eba99295f3291f1d1b5)
+++ uspace/lib/libc/arch/amd64/src/stacktrace.S	(revision 1715b6af7847ebb95ae42eba99295f3291f1d1b5)
@@ -0,0 +1,55 @@
+#
+# Copyright (c) 2009 Jakub Jermar
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+.text
+
+.global frame_pointer_get
+.global frame_pointer_prev
+.global frame_pointer_validate
+.global return_address_get
+.global program_counter_get
+
+frame_pointer_get:
+	movq %rbp, %rax
+	ret
+
+frame_pointer_prev:
+	movq (%rdi), %rax
+	ret
+
+frame_pointer_validate:
+	movq %rdi, %rax
+	ret
+
+return_address_get:
+	movq 8(%rdi), %rax
+	ret
+
+program_counter_get:
+	movq (%rsp), %rax
+	ret
Index: uspace/lib/libc/arch/arm32/Makefile.inc
===================================================================
--- uspace/lib/libc/arch/arm32/Makefile.inc	(revision bca408bfd84743b83b4ee34646013041a86f2ccf)
+++ uspace/lib/libc/arch/arm32/Makefile.inc	(revision 1715b6af7847ebb95ae42eba99295f3291f1d1b5)
@@ -38,6 +38,5 @@
 	arch/$(UARCH)/src/tls.c \
 	arch/$(UARCH)/src/eabi.S \
-	arch/$(UARCH)/src/stacktrace.c \
-	arch/$(UARCH)/src/stacktrace_asm.S
+	arch/$(UARCH)/src/stacktrace.S
 
 GCC_CFLAGS += -ffixed-r9 -mtp=soft -mapcs-frame -fno-omit-frame-pointer
Index: uspace/lib/libc/arch/arm32/include/types.h
===================================================================
--- uspace/lib/libc/arch/arm32/include/types.h	(revision bca408bfd84743b83b4ee34646013041a86f2ccf)
+++ uspace/lib/libc/arch/arm32/include/types.h	(revision 1715b6af7847ebb95ae42eba99295f3291f1d1b5)
@@ -37,6 +37,4 @@
 #define LIBC_arm32_TYPES_H_
 
-#define __32_BITS__
-
 typedef unsigned int sysarg_t;
 
Index: uspace/lib/libc/arch/arm32/src/stacktrace.S
===================================================================
--- uspace/lib/libc/arch/arm32/src/stacktrace.S	(revision 1715b6af7847ebb95ae42eba99295f3291f1d1b5)
+++ uspace/lib/libc/arch/arm32/src/stacktrace.S	(revision 1715b6af7847ebb95ae42eba99295f3291f1d1b5)
@@ -0,0 +1,55 @@
+#
+# Copyright (c) 2009 Jakub Jermar
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+.text
+
+.global frame_pointer_get
+.global frame_pointer_prev
+.global frame_pointer_validate
+.global return_address_get
+.global program_counter_get
+
+frame_pointer_get:
+	mov r0, fp
+	mov pc, lr
+
+frame_pointer_prev:
+	ldr r0, [r0, #-12]
+	mov pc, lr
+
+frame_pointer_validate:
+	mov pc, lr
+
+return_address_get:
+	ldr r0, [r0, #-4]
+	mov pc, lr
+
+program_counter_get:
+	mov r0, lr 
+	mov pc, lr
+
Index: uspace/lib/libc/arch/ia32/Makefile.inc
===================================================================
--- uspace/lib/libc/arch/ia32/Makefile.inc	(revision bca408bfd84743b83b4ee34646013041a86f2ccf)
+++ uspace/lib/libc/arch/ia32/Makefile.inc	(revision 1715b6af7847ebb95ae42eba99295f3291f1d1b5)
@@ -38,6 +38,5 @@
 	arch/$(UARCH)/src/tls.c \
 	arch/$(UARCH)/src/setjmp.S \
-	arch/$(UARCH)/src/stacktrace.c \
-	arch/$(UARCH)/src/stacktrace_asm.S
+	arch/$(UARCH)/src/stacktrace.S
 
 GCC_CFLAGS += -march=pentium
Index: uspace/lib/libc/arch/ia32/include/types.h
===================================================================
--- uspace/lib/libc/arch/ia32/include/types.h	(revision bca408bfd84743b83b4ee34646013041a86f2ccf)
+++ uspace/lib/libc/arch/ia32/include/types.h	(revision 1715b6af7847ebb95ae42eba99295f3291f1d1b5)
@@ -36,6 +36,4 @@
 #define LIBC_ia32_TYPES_H_
 
-#define __32_BITS__
-
 typedef unsigned int sysarg_t;
 
